Subject: Re: [PATCH] mdio_bus: Fix MDIO bus scanning in __mdiobus_register()

From: Florian Fainelli <[email-masked]>
Date: Thu, 28 Apr 2016 18:49:47 -0700

Le 28/04/2016 18:09, Marek Vasut a écrit :
> Since commit b74766a0a0feeef5c779709cc5d109451c0d5b17 in linux-next,
> ( phylib: don't return NULL from get_phy_device() ), phy_get_device()
> will return ERR_PTR(-ENODEV) instead of NULL if the PHY device ID is
> all ones.
> 
> This causes problem with stmmac driver and likely some other drivers
> which call mdiobus_register(). I triggered this bug on SoCFPGA MCVEVK
> board with linux-next 20160427 and 20160428. In case of the stmmac, if
> there is no PHY node specified in the DT for the stmmac block, the stmmac
> driver ( drivers/net/ethernet/stmicro/stmmac/stmmac_mdio.c function
> stmmac_mdio_register() ) will call mdiobus_register() , which will
> register the MDIO bus and probe for the PHY.
> 
> The mdiobus_register() resp. __mdiobus_register() iterates over all of
> the addresses on the MDIO bus and calls mdiobus_scan() for each of them,
> which invokes get_phy_device(). Before the aforementioned patch, the
> mdiobus_scan() would return NULL if no PHY was found on a given address
> and mdiobus_register() would continue and try the next PHY address. Now,
> mdiobus_scan() returns ERR_PTR(-ENODEV), which is caught by the
> 'if (IS_ERR(phydev))' condition and the loop exits immediatelly if the
> PHY address does not contain PHY.
> 
> Repair this by explicitly checking for the ERR_PTR(-ENODEV) and if this
> error comes around, continue with the next PHY address.
> 
> Signed-off-by: Marek Vasut <[email-masked]>
> Cc: Arnd Bergmann <[email-masked]>
> Cc: David S. Miller <[email-masked]>
> Cc: Dinh Nguyen <[email-masked]>
> Cc: Florian Fainelli <[email-masked]>
> Cc: Sergei Shtylyov <[email-masked]>

Acked-by: Florian Fainelli <[email-masked]>

I had an exact same patch posted yesterday but not formally like you
did, thanks!

> ---
>  drivers/net/phy/mdio_bus.c | 2 +-
>  1 file changed, 1 insertion(+), 1 deletion(-)
> 
> NOTE: I don't quite like this explicit check , but I don't have better idea now.
> 
> diff --git a/drivers/net/phy/mdio_bus.c b/drivers/net/phy/mdio_bus.c
> index 499003ee..388f992 100644
> --- a/drivers/net/phy/mdio_bus.c
> +++ b/drivers/net/phy/mdio_bus.c
> @@ -333,7 +333,7 @@ int __mdiobus_register(struct mii_bus *bus, struct module *owner)
>  			struct phy_device *phydev;
>  
>  			phydev = mdiobus_scan(bus, i);
> -			if (IS_ERR(phydev)) {
> +			if (IS_ERR(phydev) && (PTR_ERR(phydev) != -ENODEV)) {
>  				err = PTR_ERR(phydev);
>  				goto error;
>  			}
> 

-- 
Florian